

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   SmartSurfer Loader 1.0                                        *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2004-07-05   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



/*

	libs: MSVCRT.LIB kernel32.lib user32.lib 
	opts: /nodefaultlib:"LIBCMT.LIB" /nodefaultlib

*/

#ifdef __cplusplus
#define EXPORT extern "C" __declspec( dllexport )
#else
#define EXPORT __declspec( dllexport )
#endif


#include <windows.h>
#include <tchar.h>

#include "SmartSurfer Hook.h"
#include "devil_compile.h"


#pragma warning( disable: 4800 )

#pragma data_seg( ".SHARED" )


	FACE g_FACE;

	HHOOK g_hCBT = NULL;
	DWORD dwSmartSurferProcessId = 0;

	bool bIntroKilled = false;

	WNDPROC wndproc_OLD = NULL;
	HWND wnd_last = NULL;
	bool bKilled = false;


#pragma data_seg()
#pragma comment( linker, "/section:.SHARED,rws" )



LRESULT CALLBACK wndproc( HWND hwnd, UINT message, WPARAM wp, LPARAM lp )
{
	if( !bKilled )
	{
		switch( message )
		{
			case WM_NCACTIVATE:
			case WM_ACTIVATE:
			{
				if( wp )	// Means active
				{
					TCHAR szTitle[ 100 ] = TEXT( "" );
					GetWindowText( hwnd, szTitle, 100 );

					if(
						!_tcsncmp( ( TCHAR * )szTitle, TEXT( "Warnung" ), 7 ) ||
						!_tcscmp( ( TCHAR * )szTitle, TEXT( "WEB.DE SmartSurfer Tipp des Tages" ) )
					)
					{
						// Kill window
						PostMessage( hwnd, WM_SYSCOMMAND, SC_CLOSE, 0 );

						bKilled = true;
					}
				}
				break;
			}
		}
	}
	return CallWindowProc( wndproc_OLD, hwnd, message, wp, lp );
}


LRESULT CALLBACK hookproc_cbt( int code, WPARAM wp, LPARAM lp )
{
	if( HCBT_CREATEWND == code )
	{
		// MSDN says WE CANNOT TRUST "CBT_CREATEWND"
		// so we use only the window handle
		// and get the class name using "GetClassName". (-> Q106079)

		HWND hwnd = ( HWND )wp;

		DWORD dwProcessId;
		GetWindowThreadProcessId( hwnd, &dwProcessId );

		if( dwProcessId == dwSmartSurferProcessId )
		{
			TCHAR szClass[ 100 ] = TEXT( "" );
			GetClassName( hwnd, szClass, 100 );

			if( !_tcsncmp( szClass, TEXT( "Afx" ), 3 ) && !bIntroKilled )
			{
				// First "Afx..." window is the intro
				bIntroKilled = true;

				CallNextHookEx( g_hCBT, code, wp, lp );
				return 1;	// Deny creation
			}
			else if( !_tcsncmp( szClass, TEXT( "#32770" ), 6 ) )
			{
				if( wnd_last != NULL && IsWindow( wnd_last ) )
				{
					//Restore original wndproc
					SetWindowLong( wnd_last, GWL_WNDPROC, ( LONG )wndproc_OLD );
				}

				bKilled = false;
				wnd_last = hwnd;

				// Steal wndproc
				wndproc_OLD = ( WNDPROC )GetWindowLong( hwnd, GWL_WNDPROC );
				if( wndproc_OLD != NULL )
				{
					SetWindowLong( hwnd, GWL_WNDPROC, ( LONG )wndproc );
				}
			}
		}
	}
	return CallNextHookEx( g_hCBT, code, wp, lp );
}



bool InstallHook( HINSTANCE hMod, DWORD dwProcessId )
{
	dwSmartSurferProcessId = dwProcessId;
	g_hCBT = SetWindowsHookEx( WH_CBT, &hookproc_cbt, hMod, 0 );	// Global hook
	return ( g_hCBT != NULL );
}



bool RemoveHook()
{
	return ( bool )UnhookWindowsHookEx( g_hCBT );
}



EXPORT FACE * get_face()
{
	g_FACE.start = InstallHook;
	g_FACE.stop  = RemoveHook;

	return &g_FACE;
}